#Region Header

#NoTrayIcon
#include <GUIConstantsEx.au3>
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <GUIListView.au3>
#include <GUIImageList.au3>
#include <Misc.au3>
#include <Array.au3>

#EndRegion

#Region Global Vars

Global $iCurrent_Step				= 0
Global $iScript_Translated			= 0
Global $iLV_DblClickEvent			= 0
Global $iInputs_Changed				= 0
Global $iRestore_DefConfig			= 0

Global $sSTRUCT_TYPES 				= 'byte|boolean|char|wchar|short|ushort|word|int|long|bool|uint|ulong|dword|int64|uint64|ptr|hwnd|handle|float|double|int_ptr|long_ptr|lresult|lparam|uint_ptr|ulong_ptr|dword_ptr|wparam'
Global $sDLLCALL_TYPES 				= 'none|byte|boolean|short|ushort|word|int|long|bool|uint|ulong|dword|int64|uint64|ptr|hwnd|handle|float|double|int_ptr|long_ptr|lresult|lparam|uint_ptr|ulong_ptr|dword_ptr|wparam|str|wstr'

Global $sMarkIcon_File 				= @SystemDir & "\shell32.dll"
Global $iMarkIcon_Indx 				= 176

If FileExists(@SystemDir & "\comres.dll") Then
	$sMarkIcon_File 				= @SystemDir & "\comres.dll"
	$iMarkIcon_Indx 				= 4
EndIf

Global $iGUI_WIDTH					= 800
Global $iGUI_HEIGHT					= 700 ;700 it's a minimum to show all controls

Global $sConfig_File				= @ScriptDir & '\Config.ini'
Global $sTrnslt_ModuleTmpltFile 	= @ScriptDir & '\ATT_Module.tmplt'
Global $sTrnslt_LngTmpltFile 		= @ScriptDir & '\ATT_Language.tmplt'

Global $sTrnslt_LastAu3ScriptRead 	= ''

Global $sTrnslt_Au3Script			= ''
Global $iTrnslt_IgnrCmntdLns 		= 1
Global $sTrnslt_ArrName 			= '$aTXT'
Global $sTrnslt_ArrMsgFrmt 			= '$iMSG_%s'
Global $sTrnslt_ModuleFilePathFrmt 	= '%s\UDFs\Translation.au3'
Global $sTrnslt_LngFilePathFrmt 	= '%s\Languages\%d.lng'

Global $sTrnslt_DefLanguage 		= 'English'

;Language Names
Global $sTrnslt_Lngs 				= _
									 'English' & @CRLF & _
									 'Russian'

;Pattern for Marked lines that needs an attention (MsgBox, ToolTip, GUICtrlCreate*, etc.)
Global $sTrnslt_MarkLinesPtrns		= _
									 'ConsoleWrite\h*\(.*?\)' & @CRLF & _
									 'MsgBox\h*\(.*?\)' & @CRLF & _
									 'ToolTip\h*\(.*?\)' & @CRLF & _
									 'GUICtrlSetTip\h*\(.*?\)' & @CRLF & _
									 'GUICtrlSetData\h*\(.*?\)' & @CRLF & _
									 'GUICtrlCreate.*?\h*\(.*?\)' & @CRLF & _
									 'File((Open|Save)Dialog|SelectFolder)\h*\(.*?\)' & @CRLF & _
									 '^(((Global|Local|Dim|Const|Static) )?){0,2}\h*\$\w+(\[[^]]+\])?\h*&?=\h*("|'')' ;Variable assingment

;Ignored strings pattern
Global $sTrnslt_IgnorePtrns 		= _
									 '^[^a-zA-Z--߸]+$' & @CRLF & _ 						;Includes only non words chars
									 '\.[^.]{1,5}$' & @CRLF & _									;Kind of a file name - by extension (NOT SURE ABOUT THIS ONE)
									 '^0x$' & @CRLF & _											;Start of hex value
									 '^(0x)?[[:xdigit:]]+$' & @CRLF & _							;Hex value
									 '^((Ctrl|Shift|Alt)\h*\+\h*){1,3}[^\h]$' & @CRLF & _		;HotKey string
									 '^[\^\+!]+.*$' & @CRLF & _									;HotKeySet
									 '^{.*?}$' & @CRLF & _										;SendKeys
									 '^(?-i)[A-Z]{1,3}_[A-Z0-9_]+$' & @CRLF & _					;Windows Messages(?) and GUI constants (NOT SURE ABOUT THIS ONE)
									 '^(' & $sDLLCALL_TYPES & ')\*?$' & @CRLF & _																									;DllCall types
									 '^(' & $sSTRUCT_TYPES & ')(\h+[^;]+)?;((' & $sSTRUCT_TYPES & ')(\h+[^;]+)?(;+|$))+$' & @CRLF & _												;Structures
									 '^(HKEY_LOCAL_MACHINE|HKLM|HKEY_USERS|HKU|HKEY_CURRENT_USER|HKCU|HKEY_CLASSES_ROOT|HKCR|HKEY_CURRENT_CONFIG|HKCC)\\.*?$' & @CRLF & _			;Registry path
									 '^(CaretCoordMode|ExpandEnvStrings|ExpandVarStrings|GUICloseOnESC|GUICoordMode|GUIDataSeparatorChar|GUIOnEventMode|GUIResizeMode|' & _			;Opt strings
										'GUIEventOptions|MouseClickDelay|MouseClickDownDelay|MouseClickDragDelay|MouseCoordMode|MustDeclareVars|PixelCoordMode|SendAttachMode|' & _	;Opt strings
										'SendCapslockMode|SendKeyDelay|SendKeyDownDelay|TCPTimeout|TrayAutoPause|TrayIconDebug|TrayIconHide|TrayMenuMode|TrayOnEventMode|' & _		;Opt strings
										'WinDetectHiddenText|WinSearchChildren|WinTextMatchMode|WinTitleMatchMode|WinWaitDelay)$'													;Opt strings

If $iRestore_DefConfig Then
	_ResetIniPrefsProc()
EndIf

$sTrnslt_Au3Script 					= _Iif($CmdLine[0] > 0, $CmdLineRaw, _IniRead($sConfig_File, 'Main Prefs', 'Last Au3 Script File', $sTrnslt_Au3Script))
$iTrnslt_IgnrCmntdLns 				= _IniRead($sConfig_File, 'Main Prefs', 'Ignore Commented Lines', $iTrnslt_IgnrCmntdLns)
$sTrnslt_ArrName 					= _IniRead($sConfig_File, 'Main Prefs', 'Translation Array Name', $sTrnslt_ArrName)
$sTrnslt_ArrMsgFrmt 				= _IniRead($sConfig_File, 'Main Prefs', 'Translation Array Msg Format', $sTrnslt_ArrMsgFrmt)
$sTrnslt_ModuleFilePathFrmt 		= _IniRead($sConfig_File, 'Main Prefs', 'Module File Path Format', $sTrnslt_ModuleFilePathFrmt)
$sTrnslt_LngFilePathFrmt 			= _IniRead($sConfig_File, 'Main Prefs', 'Language File Path Format', $sTrnslt_LngFilePathFrmt)
$sTrnslt_DefLanguage 				= _IniRead($sConfig_File, 'Main Prefs', 'Default Language', $sTrnslt_DefLanguage)
$sTrnslt_Lngs 						= _IniRead($sConfig_File, 'Translation Languages', '', $sTrnslt_Lngs, 1)
$sTrnslt_MarkLinesPtrns 			= _IniRead($sConfig_File, 'Translation Mark Lines Patterns', '', $sTrnslt_MarkLinesPtrns, 1)
$sTrnslt_IgnorePtrns 				= _IniRead($sConfig_File, 'Translation Ignore Patterns', '', $sTrnslt_IgnorePtrns, 1)

#EndRegion

#Region GUI

$hGUI = GUICreate('Au3 Translation Tool', $iGUI_WIDTH, $iGUI_HEIGHT)

$iFirst_CtrlID = GUICtrlCreateDummy() + 1

$iTab = GUICtrlCreateTab(10, 20, $iGUI_WIDTH - 20, $iGUI_HEIGHT - 60)

$iStep1_TabItem = GUICtrlCreateTabItem('Step 1')

GUICtrlCreateLabel('Please select AutoIt Script, and other options...', 20, 50, $iGUI_WIDTH - 40, 20)
GUICtrlSetFont(-1, 9, 800)
GUICtrlSetColor(-1, 0xFF0000)

GUICtrlCreateLabel('Au3 Script:', 20, 102, 55, 15)
$iTrnsltAu3Script_Inpt = GUICtrlCreateInput($sTrnslt_Au3Script, 80, 100, $iGUI_WIDTH - 130, 20)
$iTrnsltAu3ScriptSel_Bttn = GUICtrlCreateButton('...', $iGUI_WIDTH - 45, 100, 25, 20)

$iTrnsltIgnrCmntdLns_CB = GUICtrlCreateCheckbox('Ignore commented lines', 20, 140)
GUICtrlSetState(-1, $iTrnslt_IgnrCmntdLns)

GUICtrlCreateLabel('Translate Array Name:', 20, 172, 160, 15)
$iTrnsltArrName_Inpt = GUICtrlCreateInput($sTrnslt_ArrName, 180, 170, $iGUI_WIDTH - 200, 20)
GUICtrlCreateLabel('Main array name for the translated strings.', 180, 190, -1, 15)
GUICtrlSetFont(-1, 8)
GUICtrlSetColor(-1, 0x888888)

GUICtrlCreateLabel('Array Msg Format:', 20, 222, 160, 15)
$iTrnsltArrMsgTmplt_Inpt = GUICtrlCreateInput($sTrnslt_ArrMsgFrmt, 180, 220, $iGUI_WIDTH - 200, 20)
GUICtrlCreateLabel('%s replaced with var name from the string.', 180, 240, -1, 15)
GUICtrlSetFont(-1, 8)
GUICtrlSetColor(-1, 0x888888)

GUICtrlCreateLabel('Module File Path Format:', 20, 272, 160, 15)
$iTrnsltMdlFilePathFrmt_Inpt = GUICtrlCreateInput($sTrnslt_ModuleFilePathFrmt, 180, 270, $iGUI_WIDTH - 200, 20)
GUICtrlCreateLabel('%s replaced with full path to Au3File''s Dir.', 180, 290, -1, 15)
GUICtrlSetFont(-1, 8)
GUICtrlSetColor(-1, 0x888888)

GUICtrlCreateLabel('Language File Path Format:', 20, 322, 160, 15)
$iTrnsltLngFilePathFrmt_Inpt = GUICtrlCreateInput($sTrnslt_LngFilePathFrmt, 180, 320, $iGUI_WIDTH - 200, 20)
GUICtrlCreateLabel('%s replaced with full path to Au3File''s Dir.' & @CRLF & '%d replaced with language name.', 180, 340, -1, 25)
GUICtrlSetFont(-1, 8)
GUICtrlSetColor(-1, 0x888888)

GUICtrlCreateLabel('Languages:', 20, 360, 160, 15)
$iTrnsltLngs_Edit = GUICtrlCreateEdit($sTrnslt_Lngs, 20, 380, $iGUI_WIDTH - 40, 70)
GUICtrlCreateLabel('Each language name on separated line.', 20, 450, -1, 15)
GUICtrlSetFont(-1, 8)
GUICtrlSetColor(-1, 0x888888)

GUICtrlCreateLabel('Default Language:', $iGUI_WIDTH - 235, 457, 90, 15)
$iTrnsltDefLng_Cmb = GUICtrlCreateCombo('', $iGUI_WIDTH - 140, 455, 120, 50, BitOr($GUI_SS_DEFAULT_COMBO, $CBS_DROPDOWNLIST))
GUICtrlSetData(-1, StringReplace($sTrnslt_Lngs, @CRLF, '|'), $sTrnslt_DefLanguage)

GUICtrlCreateLabel('Marked Lines Patterns:', 20, 485, 160, 15)
$iTrnsltMrkLnsPtrns_Edit = GUICtrlCreateEdit($sTrnslt_MarkLinesPtrns, 20, 500, ($iGUI_WIDTH / 2) - 30, 130)
GUICtrlCreateLabel('Each pattern on separated line.', 20, 630, -1, 15)
GUICtrlSetFont(-1, 8)
GUICtrlSetColor(-1, 0x888888)

GUICtrlCreateLabel('Ignore Lines Patterns:', ($iGUI_WIDTH / 2) + 10, 485, 160, 15)
$iTrnsltIgnrPtrns_Edit = GUICtrlCreateEdit($sTrnslt_IgnorePtrns, ($iGUI_WIDTH / 2) + 10, 500, ($iGUI_WIDTH / 2) - 30, 130)
GUICtrlCreateLabel('Each pattern on separated line.', ($iGUI_WIDTH / 2) + 10, 630, -1, 15)
GUICtrlSetFont(-1, 8)
GUICtrlSetColor(-1, 0x888888)

$iStep2_TabItem = GUICtrlCreateTabItem('Step 2')

$iStatus_Lbl = GUICtrlCreateLabel('', 20, 60, $iGUI_WIDTH - 40, 17, $SS_CENTER)
GUICtrlSetFont(-1, 9, 800)
GUICtrlSetColor(-1, 0x0000FF)

GUICtrlCreateLabel('Select strings that should be translated:', 20, 60, -1, 15)

GUICtrlCreateLabel("1)", 20, 80, 45, 17)
GUICtrlSetFont(-1, 9, 800)
GUICtrlSetColor(-1, 0x0000FF)

GUICtrlCreateLabel("'~*~*~'", 50, 81, 45, 17)
GUICtrlSetFont(-1, 9, 600)
GUICtrlSetColor(-1, 0x888888)
GUICtrlCreateLabel("=", 100, 81, 10, 17)
GUICtrlSetFont(-1, 9, 800)
GUICtrlSetColor(-1, 0xFF0000)
GUICtrlCreateLabel("|", 115, 80, 10, 17)
GUICtrlSetFont(-1, 8.5, 600)
GUICtrlSetColor(-1, 0x888888)

GUICtrlCreateLabel("2)", 20, 100, 45, 17)
GUICtrlSetFont(-1, 9, 800)
GUICtrlSetColor(-1, 0x0000FF)

GUICtrlCreateIcon($sMarkIcon_File, -($iMarkIcon_Indx + 1), 65, 101, 16, 16, $BS_ICON)
GUICtrlSetFont(-1, 9, 600)
GUICtrlSetColor(-1, 0x888888)
GUICtrlCreateLabel("=", 100, 101, 10, 17)
GUICtrlSetFont(-1, 9, 800)
GUICtrlSetColor(-1, 0xFF0000)
GUICtrlCreateLabel("Marked string", 115, 100, 100, 17)
GUICtrlSetFont(-1, 8.5, 600)
GUICtrlSetColor(-1, 0x888888)

$iShowFullLine_Bttn = GUICtrlCreateButton('Show full line', $iGUI_WIDTH - 110, 95, 90, 20)
GUICtrlSetTip(-1, 'Same as Double Click on the item')
$iLV = GUICtrlCreateListView('Line #|String|Full Line', 20, 120, $iGUI_WIDTH - 40, $iGUI_HEIGHT - 190, BitOR($LVS_SHOWSELALWAYS, $LVS_NOSORTHEADER))
_GUICtrlListView_SetExtendedListViewStyle($iLV, BitOR($LVS_EX_CHECKBOXES, $LVS_EX_FULLROWSELECT, $LVS_EX_SUBITEMIMAGES))

$hImageList = _GUIImageList_Create(16, 16, 5, 3)
_GUIImageList_AddIcon($hImageList, $sMarkIcon_File, $iMarkIcon_Indx)
_GUICtrlListView_SetImageList($iLV, $hImageList, 1)

$iCheckAll_Bttn = GUICtrlCreateButton('Check All', 20, $iGUI_HEIGHT - 65, 70, 20)
$iUnCheckAll_Bttn = GUICtrlCreateButton('UnCheck All', 95, $iGUI_HEIGHT - 65, 70, 20)
$iCheckSelected_Bttn = GUICtrlCreateButton('Check Selected', 180, $iGUI_HEIGHT - 65, 100, 20)
$iUnCheckSelected_Bttn = GUICtrlCreateButton('UnCheck Selected', 285, $iGUI_HEIGHT - 65, 100, 20)
$iCheckMarked_Bttn = GUICtrlCreateButton('Check Marked', 400, $iGUI_HEIGHT - 65, 100, 20)
$iUnCheckMarked_Bttn = GUICtrlCreateButton('UnCheck Marked', 505, $iGUI_HEIGHT - 65, 100, 20)

GUICtrlCreateTabItem('')

$iPrevStep_Bttn = GUICtrlCreateButton('<< Previous', 10, $iGUI_HEIGHT - 30, 70, 20)
GUICtrlSetState(-1, $GUI_DISABLE)
$iNextStep_Bttn = GUICtrlCreateButton('Next >>', 90, $iGUI_HEIGHT - 30, 70, 20)

$iLast_CtrlID = GUICtrlCreateDummy() - 1

GUISetState(@SW_SHOW, $hGUI)

#EndRegion

#Region Options & Initialization

GUIRegisterMsg($WM_NOTIFY, 'WM_NOTIFY')
GUIRegisterMsg($WM_COMMAND, 'WM_COMMAND')
OnAutoItExitRegister('_OnExitProc')

#EndRegion

#Region Main Loop

While 1
	$iMsg = GUIGetMsg()
	
	If $iLV_DblClickEvent Then
		$iLV_DblClickEvent = 0
		$iMsg = $iShowFullLine_Bttn
	EndIf
	
	Switch $iMsg
		Case $GUI_EVENT_CLOSE
			Exit
		Case $iTrnsltAu3ScriptSel_Bttn
			$sTrnslt_Au3Script = GUICtrlRead($iTrnsltAu3Script_Inpt)
			
			Local $sTrnslt_Au3ScriptPath = StringRegExpReplace($sTrnslt_Au3Script, '\\[^\\]*$', '')
			Local $sTrnslt_Au3ScriptName = StringRegExpReplace($sTrnslt_Au3Script, '^.*\\', '')
			
			$sTrnslt_Au3Script = FileOpenDialog('Select Au3 Script File', $sTrnslt_Au3ScriptPath, 'AutoIt Script (*.au3)', 11, $sTrnslt_Au3ScriptName, $hGUI)
			If @error Then ContinueLoop
			
			GUICtrlSetData($iTrnsltAu3Script_Inpt, $sTrnslt_Au3Script)
		Case $iTrnsltIgnrCmntdLns_CB
			$iInputs_Changed = _Iif(GUICtrlRead($iTrnsltIgnrCmntdLns_CB) = $iTrnslt_IgnrCmntdLns, 0, $iTrnsltIgnrCmntdLns_CB)
		Case $iShowFullLine_Bttn
			$sTrnslt_Au3Script = GUICtrlRead($iTrnsltAu3Script_Inpt)
			
			Local $sSelIndx = _GUICtrlListView_GetSelectedIndices($iLV)
			Local $iLine = Number(_GUICtrlListView_GetItemText($iLV, Number($sSelIndx), 0))
			Local $sLine = StringStripWS(StringReplace(_GUICtrlListView_GetItemText($iLV, Number($sSelIndx), 2), '~*~*~', '|'), 3) ;FileReadLine($sTrnslt_Au3Script, $iLine)
			
			If $sSelIndx Then
				GUISetState(@SW_DISABLE, $hGUI)
				Local $hLineGUI = GUICreate('Line #' & $iLine, 600, 120, -1, -1, -1, $WS_EX_TOOLWINDOW, $hGUI)
				Local $iLine_Edit = GUICtrlCreateEdit($sLine, 10, 10, 580, 100, BitOr($GUI_SS_DEFAULT_EDIT, $ES_READONLY))
				GUISetState(@SW_SHOW, $hLineGUI)
				
				Do
				Until GUIGetMsg() = $GUI_EVENT_CLOSE
				
				GUISetState(@SW_ENABLE, $hGUI)
				GUIDelete($hLineGUI)
			EndIf
		Case $iCheckAll_Bttn
			_GUICtrlListView_SetItemChecked($iLV, -1, True)
		Case $iUnCheckAll_Bttn
			_GUICtrlListView_SetItemChecked($iLV, -1, False)
		Case $iCheckSelected_Bttn, $iUnCheckSelected_Bttn
			Local $aSelected = _GUICtrlListView_GetSelectedIndices($iLV, True)
			Local $bChecked = True
			If $iMsg = $iUnCheckSelected_Bttn Then $bChecked = False
			
			For $i = 1 To UBound($aSelected)-1
				_GUICtrlListView_SetItemChecked($iLV, $aSelected[$i], $bChecked)
			Next
		Case $iCheckMarked_Bttn, $iUnCheckMarked_Bttn
			Local $bChecked = True
			If $iMsg = $iUnCheckMarked_Bttn Then $bChecked = False
			
			For $i = 0 To _GUICtrlListView_GetItemCount($iLV)-1
				If _GUICtrlListView_GetItemImage($iLV, $i, 2) <> -1 Then
					_GUICtrlListView_SetItemChecked($iLV, $i, $bChecked)
				EndIf
			Next
		Case $iTab
			Local $iStep = GUICtrlRead($iTab)
			
			If $iStep > $iCurrent_Step Then
				ControlClick($hGUI, '', $iNextStep_Bttn)
			Else
				ControlClick($hGUI, '', $iPrevStep_Bttn)
			EndIf
		Case $iNextStep_Bttn, $iPrevStep_Bttn
			$iScript_Translated = 0
			
			$sTrnslt_Au3Script = GUICtrlRead($iTrnsltAu3Script_Inpt)
			
			Local $sTrnslt_Au3ScriptRead = FileRead($sTrnslt_Au3Script)
			Local $iItems = 0, $iChecked_Count
			
			If Not FileExists($sTrnslt_Au3Script) Or StringRight($sTrnslt_Au3Script, 4) <> '.au3' Then
				MsgBox(48, 'Error', 'Script file not found.', 0, $hGUI)
				GUICtrlSetState($iStep1_TabItem, $GUI_SHOW)
				ContinueLoop
			EndIf
			
			If StringRegExp($sTrnslt_Au3ScriptRead, '#include "' & StringReplace(StringReplace($sTrnslt_ModuleFilePathFrmt, '%s\', ''), '\', '\\') & '"\r?\n') Then
				;MsgBox(48, 'Error', 'Script file already translated.', 0, $hGUI)
				;GUICtrlSetState($iStep1_TabItem, $GUI_SHOW)
				;ContinueLoop
				
				$iScript_Translated = 1
			EndIf
			
			WinSetTitle($hGUI, '', StringRegExpReplace(WinGetTitle($hGUI), ' - .*?$', '') & _Iif(GUICtrlRead($iTab) = 1, StringRegExpReplace($sTrnslt_Au3Script, '^.*\\', ' - '), ''))
			AdlibRegister('_GUICheckEventsProc', 10)
			
			If $iMsg = $iNextStep_Bttn Then
				$iCurrent_Step += 1
			Else
				$iCurrent_Step -= 1
			EndIf
			
			Switch $iCurrent_Step
				Case 0
					GUICtrlSetState($iPrevStep_Bttn, $GUI_DISABLE)
					GUICtrlSetState($iStep1_TabItem, $GUI_SHOW)
					GUICtrlSetData($iNextStep_Bttn, 'Next >>')
				Case 1
					GUICtrlSetState($iStep2_TabItem, $GUI_SHOW)
					GUICtrlSetState($iPrevStep_Bttn, $GUI_ENABLE)
					GUICtrlSetData($iNextStep_Bttn, 'Translate')
					
					If $sTrnslt_LastAu3ScriptRead <> $sTrnslt_Au3ScriptRead Or $iInputs_Changed Then
						_GUISetStateProc($GUI_DISABLE, $iStatus_Lbl)
						GUICtrlSetData($iStatus_Lbl, 'Please wait, generating translation strings...')
						
						_SetGUIPrefsProc()
						
						$sTrnslt_LastAu3ScriptRead = $sTrnslt_Au3ScriptRead
						$iInputs_Changed = 0
						
						Local $aStrs = _Au3GetStrings($sTrnslt_Au3Script)
						Local $sMarkLinesPtrns = StringReplace($sTrnslt_MarkLinesPtrns, @CRLF, '|')
						Local $sIgnorePtrns = StringReplace($sTrnslt_IgnorePtrns, @CRLF, '|')
						
						_GUICtrlListView_BeginUpdate($iLV)
						_GUICtrlListView_DeleteAllItems($iLV)
						
						For $i = 1 To UBound($aStrs)-1
							If Not StringRegExp(StringRegExpReplace($aStrs[$i][1], '^[''"]|[''"]$', ''), '(?i)(' & $sIgnorePtrns & ')') Then
								GUICtrlCreateListViewItem($aStrs[$i][0] & '|' & StringReplace($aStrs[$i][1], '|', '~*~*~') & '|' & StringReplace($aStrs[$i][2], '|', '~*~*~'), $iLV)
								
								If StringRegExp($aStrs[$i][2], '(?i)(' & $sMarkLinesPtrns & ')') Then
									_GUICtrlListView_SetItemImage($iLV, $iItems, 0, 2)
								EndIf
								
								$iItems += 1
							EndIf
						Next
						
						_GUICtrlListView_SetColumnWidth($iLV, 0, 80)
						_GUICtrlListView_SetColumnWidth($iLV, 1, ($iGUI_WIDTH / 2) - 80)
						_GUICtrlListView_SetColumnWidth($iLV, 2, ($iGUI_WIDTH / 2) - 80)
						
						_GUICtrlListView_EndUpdate($iLV)
						
						_GUISetStateProc($GUI_ENABLE, $iStatus_Lbl)
						GUICtrlSetData($iStatus_Lbl, '')
					EndIf
					
					If _GUICtrlListView_GetItemCount($iLV) = 0 Then
						MsgBox(48, 'Error', 'Strings not found.', 0, $hGUI)
						
						GUICtrlSetState($iPrevStep_Bttn, $GUI_DISABLE)
						GUICtrlSetState($iStep1_TabItem, $GUI_SHOW)
						GUICtrlSetData($iNextStep_Bttn, 'Next >>')
						
						$iCurrent_Step = 0
					EndIf
				Case 2
					$iChecked_Count = _GUICtrlListView_GetItemCheckedCount($iLV)
					
					If $iChecked_Count = 0 Then
						MsgBox(48, 'Error!', 'No strings to translate, please check at least one string.', 0, $hGUI)
						$iCurrent_Step -= 1
					Else
						_GUISetStateProc($GUI_DISABLE, $iStatus_Lbl)
						GUICtrlSetData($iStatus_Lbl, 'Please wait, generating translation module...')
						
						_Au3TranslateProc()
						
						_GUISetStateProc($GUI_ENABLE, $iStatus_Lbl)
						GUICtrlSetData($iStatus_Lbl, '')
						
						MsgBox(64, 'Completed!', _
							'Translation module was generated successfuly.' & @CRLF & _
							'Translated strings: ' & $iChecked_Count & @CRLF & @CRLF & _
							'Now you can use Language Selection Function:' & @CRLF & _
							'$sDefLng = _AppTranslation_SelectLangGUI($sAppName, $hParent = 0, $sDefLng = "")' & @CRLF & @CRLF & _
							'And use Language Registration Function:' & @CRLF & _
							'$aTXT = _AppTranslation_Register($LANGS_DIR & "\" & $sDefLng & ".lng")', 0, $hGUI)
						
						$iCurrent_Step = 0
						GUICtrlSetState($iPrevStep_Bttn, $GUI_DISABLE)
						GUICtrlSetState($iStep1_TabItem, $GUI_SHOW)
						GUICtrlSetData($iNextStep_Bttn, 'Next >>')
					EndIf
			EndSwitch
			
			AdlibUnRegister('_GUICheckEventsProc')
	EndSwitch
WEnd

#EndRegion

#Region Functions

Func _Au3TranslateProc()
	$sTrnslt_Au3Script = GUICtrlRead($iTrnsltAu3Script_Inpt)
	
	Local $sTrnslt_Au3ScriptPath = StringRegExpReplace($sTrnslt_Au3Script, '\\[^\\]*$', '')
	Local $sTrnslt_Au3ScriptName = StringRegExpReplace($sTrnslt_Au3Script, '^.*\\', '')
	Local $sTrnslt_Au3ScriptRead = FileRead($sTrnslt_Au3Script)
	Local $aTrnslt_Au3ScriptRead = StringSplit(StringStripCR($sTrnslt_Au3ScriptRead), @LF)
	
	Local $iLastSel = -1, $iChecked = 0, $iItems = _GUICtrlListView_GetItemCount($iLV)
	Local $aVars[$iItems + 1], $sVars = '|', $sOld_Vars, $iSrchIndx, $aVarNum, $iLine, $sStr, $sFullStrLine, $sFuncName
	Local $sTrnsltFncStrs, $sOld_TrnsltFncsStrs, $sTrnsltStrs, $sOrigin_TrnsltStrs, $sOld_TrnsltStrs, $sTrnslt_LngFile, $sTrnslt_ModuleFile, $sTrnslt_LngFileName, $sTrnslt_ModuleFileRelPath
	Local $sTemplate, $sAuthor, $sVersion, $aLangs, $hFile
	
	For $i = 0 To $iItems - 1
		If _GUICtrlListView_GetItemChecked($iLV, $i) Then
			$iChecked += 1
			
			_GUICtrlListView_SetItemSelected($iLV, $iLastSel, False)
			_GUICtrlListView_SetItemSelected($iLV, $i, True)
			_GUICtrlListView_EnsureVisible($iLV, $i)
			
			$iLastSel = $i
			
			$iLine = Number(_GUICtrlListView_GetItemText($iLV, $i, 0))
			$sStr = StringReplace(_GUICtrlListView_GetItemText($iLV, $i, 1), '~*~*~', '|', 0, 2)
			$sFullStrLine = StringReplace(_GUICtrlListView_GetItemText($iLV, $i, 2), '~*~*~', '|', 0, 2)
			
			If $iLine <= $aTrnslt_Au3ScriptRead[0] Then
				$sFuncName = StringRegExpReplace($sFullStrLine, '.*?(?:(\w+)\h*\(.*?|\$(\w+)\h*=\h*)\Q' & $sStr & '\E.*', '\1\2')
				
				If Not @extended Then
					$sFuncName = ''
				Else
					$sFuncName = StringRegExpReplace($sFuncName, '\W+', '')
				EndIf
				
				$sVar = _Au3GetVarFromString($sStr, $sFuncName)
				
				While 1
					$iSrchIndx = _ArraySearch($aVars, $sVar, 1, $aVars[0])
					
					If $iSrchIndx = -1 Then
						ExitLoop
					EndIf
					
					$aVarNum = StringRegExp($aVars[$iSrchIndx], '^(.*)_(\d+)$', 3)
					
					If UBound($aVarNum) > 1 Then
						$sVar = $aVarNum[0] & '_' & Number($aVarNum[1]) + 1
					Else
						$sVar &= '_1'
					EndIf
				WEnd
				
				$sFullVar = $sTrnslt_ArrName & '[' & StringReplace($sTrnslt_ArrMsgFrmt, '%s', $sVar, 0, 2) & ']'
				$sTrnsltFncStrs &= $sFullVar & ' = _AppTranslation_GetString($sLangFile, "' & $sVar & '", ' & $sStr & ', $iFileEncoding)' & @CRLF & @TAB
				$sTrnsltStrs &= $sVar & '=' & $sStr & @CRLF
				
				$sVars &= $sVar & '|'
				$aVars[0] += 1
				$aVars[$aVars[0]] = $sVar
				
				$aTrnslt_Au3ScriptRead[$iLine] = StringReplace($aTrnslt_Au3ScriptRead[$iLine], $sStr, $sFullVar, 1, 2)
			EndIf
		EndIf
	Next
	
	If $iChecked = 0 Then
		Return SetError(1)
	EndIf
	
	$aVars = StringSplit(StringRegExpReplace($sVars, '^\||\|$', ''), '|')
	$sVars = ''
	$iC = 0
	
	For $i = 1 To $aVars[0]
		$iC += 1
		
		$sVars &= StringReplace($sTrnslt_ArrMsgFrmt, '%s', $aVars[$i]) & ', '
		
		If $iC = 5 And $i < $aVars[0] Then
			$iC = 0
			$sVars &= '_' & @CRLF & @TAB & @TAB
		EndIf
	Next
	
	$sVars &= '_'
	$sTrnsltFncStrs = StringStripWS($sTrnsltFncStrs, 3)
	$sTrnsltStrs = StringStripWS($sTrnsltStrs, 3)
	$sOrigin_TrnsltStrs = $sTrnsltStrs
	
	$sTrnslt_ModuleFile = StringReplace($sTrnslt_ModuleFilePathFrmt, '%s', $sTrnslt_Au3ScriptPath)
	$sTrnslt_ModuleFileRelPath = StringRegExpReplace($sTrnslt_ModuleFilePathFrmt, '^%s\\', '')
	
	If $iScript_Translated Then
		$sRead = FileRead($sTrnslt_ModuleFile)
		
		$sOld_Vars = StringRegExpReplace($sRead, '(?si).*\$iMSG_First = 0, _\s+(.*?)\s+\$iMSG_Last.*', '\1')
		
		If @extended And $sOld_Vars <> '' Then
			$sVars = $sOld_Vars & @CRLF & @TAB & @TAB & $sVars
		EndIf
		
		$sOld_TrnsltFncsStrs = StringRegExpReplace($sRead, '(?si).*;Default values\s+(.*?)\s+If \$sSetDataFunc <> "" Then.*', '\1')
		
		If @extended And $sOld_TrnsltFncsStrs <> '' Then
			$sTrnsltFncStrs = $sOld_TrnsltFncsStrs & @CRLF & @TAB & $sTrnsltFncStrs
		EndIf
	EndIf
	
	$sTemplate = FileRead($sTrnslt_ModuleTmpltFile)
	$sTemplate = StringReplace($sTemplate, '%MSG%', $sVars)
	$sTemplate = StringReplace($sTemplate, '%TXT%', $sTrnsltFncStrs)
	$sTemplate = StringReplace($sTemplate, '%aTXT%', $sTrnslt_ArrName)
	$sTemplate = StringReplace($sTemplate, '%LngName%', $sTrnslt_DefLanguage)
	$sTemplate = StringReplace($sTemplate, '%LngsDir%', StringRegExpReplace(StringReplace($sTrnslt_LngFilePathFrmt, '%s\', "@ScriptDir & '\"), '\\[^\\]*$', '') & "'")
	
	;Backup Translation.au3 Module
	FileMove($sTrnslt_ModuleFile, $sTrnslt_ModuleFile & '.bak', 1)
	
	;Write Translation.au3 Module
	$hFile = FileOpen($sTrnslt_ModuleFile, 2+8)
	FileWrite($hFile, $sTemplate)
	FileClose($hFile)
	
	;Write Language Files
	$aLangs = StringSplit(StringStripWS($sTrnslt_Lngs, 3), @CRLF, 1)
	
	For $i = 1 To $aLangs[0]
		$sTrnsltStrs = $sOrigin_TrnsltStrs
		
		$sTrnslt_LngFile = StringReplace($sTrnslt_LngFilePathFrmt, '%s', $sTrnslt_Au3ScriptPath)
		$sTrnslt_LngFile = StringReplace($sTrnslt_LngFile, '%d', _FileGetValidName($aLangs[$i]))
		$sTrnslt_LngFileName = StringRegExpReplace($sTrnslt_LngFile, '^.*\\', '')
		
		If $iScript_Translated Then
			$sRead = FileRead($sTrnslt_LngFile)
			
			$sOld_TrnsltStrs = StringRegExpReplace($sRead, '(?si).*\[Translation\]\s+(.*?)', '\1')
			
			If @extended And $sOld_TrnsltStrs <> '' Then
				$sTrnsltStrs = StringStripWS($sOld_TrnsltStrs, 3) & @CRLF & $sTrnsltStrs
			EndIf
		EndIf
		
		$sTemplate = FileRead($sTrnslt_LngTmpltFile)
		$sTemplate = StringReplace($sTemplate, '%Program%', StringRegExpReplace($sTrnslt_Au3ScriptName, '(?i)\.au3$', ''))
		$sTemplate = StringReplace($sTemplate, '%Language%', $aLangs[$i])
		$sTemplate = StringReplace($sTemplate, '%Strings%', $sTrnsltStrs)
		
		$sAuthor = @UserName
		
		If StringRegExp($sTrnslt_Au3ScriptRead, '(^|\r?\n)\h*Author:\h+') Then
			$sAuthor = StringRegExpReplace($sTrnslt_Au3ScriptRead, '(?s)(?:^|.*\r?\n)\h*Author:\h*([^\r\n]*).*', '\1')
		ElseIf StringRegExp($sTrnslt_Au3ScriptRead, '(^|\r?\n)\h*#AutoIt3Wrapper_Res_LegalCopyright=') Then
			$sAuthor = StringRegExpReplace($sTrnslt_Au3ScriptRead, '(?s)(?:^|.*\r?\n)\h*#AutoIt3Wrapper_Res_LegalCopyright=([^\r\n]*).*', '\1')
		EndIf
		
		$sTemplate = StringReplace($sTemplate, '%Author%', $sAuthor)
		
		$sVersion = '0.1'
		
		If StringRegExp($sTrnslt_Au3ScriptRead, '(^|\r?\n)\h*Version:\h+') Then
			$sVersion = StringRegExpReplace($sTrnslt_Au3ScriptRead, '(?s)(?:^|.*\r?\n)\h*Version:\h*([^\r\n]*).*', '\1')
		ElseIf StringRegExp($sTrnslt_Au3ScriptRead, '(^|\r?\n)\h*#AutoIt3Wrapper_Version=') Then
			$sVersion = StringRegExpReplace($sTrnslt_Au3ScriptRead, '(?s)(?:^|.*\r?\n)\h*#AutoIt3Wrapper_Version=([^\r\n]*).*', '\1')
		EndIf
		
		$sTemplate = StringReplace($sTemplate, '%Version%', $sVersion)
		
		FileMove($sTrnslt_LngFile, $sTrnslt_LngFile & '.bak', 1)
		$hFile = FileOpen($sTrnslt_LngFile, 2+8)
		FileWrite($hFile, $sTemplate)
		FileClose($hFile)
	Next
	
	;Replace the strings in file
	FileMove($sTrnslt_Au3Script, $sTrnslt_Au3Script & '.bak', 1)
	
	$hFile = FileOpen($sTrnslt_Au3Script, 2)
	
	If Not $iScript_Translated Then
		FileWriteLine($hFile, '#include "' & $sTrnslt_ModuleFileRelPath & '"' & @CRLF & @CRLF)
	EndIf
	
	For $i = 1 To $aTrnslt_Au3ScriptRead[0]
		FileWriteLine($hFile, $aTrnslt_Au3ScriptRead[$i])
	Next
	
	FileClose($hFile)
EndFunc

Func _Au3GetVarFromString($sStr, $sFuncName, $iVarMaxLen = 30)
	Local $aSplit = StringSplit($sStr, ' ')
	Local $sVar = $sFuncName & _Iif($sFuncName = '', '', '_'), $sConvert
	
	For $i = 1 To $aSplit[0]
		$sConvert = StringRegExpReplace($aSplit[$i], '\W', '')
		
		If $sConvert = '' Then
			;Add here translitiration processing
			$sConvert = '_'
		EndIf
		
		$sVar &= StringUpper(StringLeft($sConvert, 1)) & StringTrimLeft($sConvert, 1)
	Next
	
	If StringLen($sVar) > $iVarMaxLen Then
		$sVar = StringLeft($sVar, Floor($iVarMaxLen / 2)) & '_' & StringRight($sVar, Floor($iVarMaxLen / 2))
	EndIf
	
	Return $sVar
EndFunc

Func _Au3GetStrings($sTrnslt_Au3Script)
	Local $aRet[1][1], $aStrs, $sRead, $aRead, $sCmmntsEnd
	
	$sRead = FileRead($sTrnslt_Au3Script)
	
;~ 	If $iTrnslt_IgnrCmntdLns = 1 Then
;~ 		$sRead = StringRegExpReplace($sRead, '(?is)#(cs|comments-start).*#(ce|comments-end)', '')
;~ 		$sRead = StringRegExpReplace($sRead, '(?i)(^|\r?\n)\h*;.*', '')
;~ 	EndIf
	
	$aRead = StringSplit(StringStripCR($sRead), @LF)
	
	For $i = 1 To $aRead[0]
		If $iTrnslt_IgnrCmntdLns = 1 Then
			;Single commented line
			If StringRegExp($aRead[$i], '(?i)^\h*;') Then
				ContinueLoop
			EndIf
			
			;Block of commented lines
			If StringRegExp($aRead[$i], '(?i)^\h*#(cs|comments-start)') Then
				$sCmmntsEnd = 'ce'
				If StringRegExp($aRead[$i], '(?i)^\h*#comments-start') Then $sCmmntsEnd = 'comments-end'
				
				For $j = $i + 1 To $aRead[0]
					If StringRegExp($aRead[$j], '(?i)^\h*#' & $sCmmntsEnd) Then
						ExitLoop
					EndIf
				Next
				
				$i = $j
				ContinueLoop
			EndIf
		EndIf
		
		$aStrs = StringRegExp($aRead[$i], '(''(?:[^''\r\n]*(?:'''')*[^''\r\n]*)*?''(?!'')|"(?:[^"\r\n]*(?:"")*[^"\r\n]*)*?"(?!"))', 3)
		
		For $j = 0 To UBound($aStrs)-1
			If $aStrs[$j] = "''" Or $aStrs[$j] = '""' Then
				ContinueLoop
			EndIf
			
			$aRet[0][0] += 1
			ReDim $aRet[$aRet[0][0] + 1][3]
			$aRet[$aRet[0][0]][0] = $i
			$aRet[$aRet[0][0]][1] = $aStrs[$j]
			$aRet[$aRet[0][0]][2] = $aRead[$i]
		Next
	Next
	
	Return $aRet
EndFunc

Func WM_NOTIFY($hWnd, $iMsg, $wParam, $lParam)
	Local $hWndFrom, $iIDFrom, $iCode, $tNMHDR, $hWndListView
	
	$hListView = GUICtrlGetHandle($iLV)
	
	$tNMHDR = DllStructCreate($tagNMHDR, $lParam)
	
	$hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
	$iIDFrom = DllStructGetData($tNMHDR, "IDFrom")
	$iCode = DllStructGetData($tNMHDR, "Code")
	
	Switch $hWndFrom
		Case $hListView
			Switch $iCode
				Case $LVN_BEGINDRAG ; A drag-and-drop operation involving the left mouse button is being initiated
					Return 1
				Case $NM_DBLCLK, $NM_RDBLCLK ; Sent by a list-view control when the user double-clicks an item with the left/right mouse button
					$iLV_DblClickEvent = 1
			EndSwitch
	EndSwitch
	
	Return $GUI_RUNDEFMSG
EndFunc

Func WM_COMMAND($hWnd, $nMsg, $wParam, $lParam)
	Local $nNotifyCode = BitShift($wParam, 16)
	Local $nID = BitAND($wParam, 0xFFFF)
	Local $hCtrl = $lParam
	
	Switch $nNotifyCode
		Case $EN_CHANGE, $EN_UPDATE ;, $CBN_EDITCHANGE, $CBN_EDITUPDATE
			$iInputs_Changed = $nID
			
			GUICtrlSetData($iTrnsltDefLng_Cmb, '')
			GUICtrlSetData($iTrnsltDefLng_Cmb, StringReplace(GUICtrlRead($iTrnsltLngs_Edit), @CRLF, '|'), $sTrnslt_DefLanguage)
		Case $CBN_SELCHANGE
			$sTrnslt_DefLanguage = GUICtrlRead($iTrnsltDefLng_Cmb)
	EndSwitch
	
	Return $GUI_RUNDEFMSG
EndFunc

Func _IniRead($sFileName, $sSection, $sKey, $vDefault = '', $iFlag = 0)
	Local $sRet, $aSect
	
	If $iFlag = 1 Then
		$aSect = IniReadSection($sFileName, $sSection)
		
		For $i = 1 To UBound($aSect)-1
			$sRet &= $aSect[$i][1]
			If $i < $aSect[0][0] Then $sRet &= @CRLF
		Next
		
		If $sRet <> '' Then
			Return $sRet
		EndIf
	EndIf
	
	Return IniRead($sFileName, $sSection, $sKey, $vDefault)
EndFunc

Func _IniWrite($sFileName, $sSection, $sKey, $vValue, $iFlag = 0)
	Local $sRet, $aSplit
	
	If $iFlag = 1 Then
		$aSplit = StringSplit($vValue, @CRLF, 1)
		
		For $i = 1 To $aSplit[0]
			IniWrite($sFileName, $sSection, $sKey & $i, $aSplit[$i])
		Next
		
		Return 1
	EndIf
	
	IniWrite($sFileName, $sSection, $sKey, $vValue)
EndFunc

Func _FileGetValidName($sString, $sPattern = '[*?\\/|:<>"]', $sReplace = '_')
	If StringStripWS($sString, 8) = '' Then Return $sString
	
	$sString = StringRegExpReplace($sString, $sPattern, $sReplace)
	Return SetExtended(@extended, StringRegExpReplace($sString, '(' & $sReplace & '+)', $sReplace))
EndFunc

Func _GUICtrlListView_GetItemCheckedCount($hWnd)
	Local $iCount = 0
	
	For $i = 0 To _GUICtrlListView_GetItemCount($hWnd) - 1
		If _GUICtrlListView_GetItemChecked($hWnd, $i) Then
			$iCount += 1
		EndIf
	Next
	
	Return $iCount
EndFunc

Func _GUISetStateProc($iState, $iIgnore_CtrlID = 0)
	For $iCtrlID = $iFirst_CtrlID To $iLast_CtrlID
		If $iCtrlID <> $iIgnore_CtrlID Then
			GUICtrlSetState($iCtrlID, $iState)
		EndIf
	Next
EndFunc

Func _GUICheckEventsProc()
	Switch GUIGetMsg()
		Case $GUI_EVENT_CLOSE
			If MsgBox(52, 'Attention', 'Are you sure, abort the translation and Exit?', 0, $hGUI) = 6 Then
				Exit
			EndIf
	EndSwitch
EndFunc

Func _ResetIniPrefsProc()
	IniDelete($sConfig_File, 'Main Prefs')
	IniDelete($sConfig_File, 'Translation Languages')
	IniDelete($sConfig_File, 'Translation Mark Lines Patterns')
	IniDelete($sConfig_File, 'Translation Ignore Patterns')
EndFunc

Func _SetGUIPrefsProc()
	$sTrnslt_Au3Script = GUICtrlRead($iTrnsltAu3Script_Inpt)
	$iTrnslt_IgnrCmntdLns = GUICtrlRead($iTrnsltIgnrCmntdLns_CB)
	$sTrnslt_ArrName = GUICtrlRead($iTrnsltArrName_Inpt)
	$sTrnslt_ArrMsgFrmt = GUICtrlRead($iTrnsltArrMsgTmplt_Inpt)
	$sTrnslt_ModuleFilePathFrmt = GUICtrlRead($iTrnsltMdlFilePathFrmt_Inpt)
	$sTrnslt_LngFilePathFrmt = GUICtrlRead($iTrnsltLngFilePathFrmt_Inpt)
	$sTrnslt_DefLanguage = GUICtrlRead($iTrnsltDefLng_Cmb)
	$sTrnslt_Lngs = StringStripWS(GUICtrlRead($iTrnsltLngs_Edit), 3)
	$sTrnslt_MarkLinesPtrns = StringStripWS(GUICtrlRead($iTrnsltMrkLnsPtrns_Edit), 3)
	$sTrnslt_IgnorePtrns = StringStripWS(GUICtrlRead($iTrnsltIgnrPtrns_Edit), 3)
EndFunc

Func _OnExitProc()
	_SetGUIPrefsProc()
	_ResetIniPrefsProc()
	
	_IniWrite($sConfig_File, 'Main Prefs', 'Last Au3 Script File', $sTrnslt_Au3Script)
	_IniWrite($sConfig_File, 'Main Prefs', 'Ignore Commented Lines', $iTrnslt_IgnrCmntdLns)
	_IniWrite($sConfig_File, 'Main Prefs', 'Translation Array Name', $sTrnslt_ArrName)
	_IniWrite($sConfig_File, 'Main Prefs', 'Translation Array Msg Format', $sTrnslt_ArrMsgFrmt)
	_IniWrite($sConfig_File, 'Main Prefs', 'Module File Path Format', $sTrnslt_ModuleFilePathFrmt)
	_IniWrite($sConfig_File, 'Main Prefs', 'Language File Path Format', $sTrnslt_LngFilePathFrmt)
	_IniWrite($sConfig_File, 'Main Prefs', 'Default Language', $sTrnslt_DefLanguage)
	_IniWrite($sConfig_File, 'Translation Languages', 'Language #', $sTrnslt_Lngs, 1)
	_IniWrite($sConfig_File, 'Translation Mark Lines Patterns', 'Pattern #', $sTrnslt_MarkLinesPtrns, 1)
	_IniWrite($sConfig_File, 'Translation Ignore Patterns', 'Pattern #', $sTrnslt_IgnorePtrns, 1)
EndFunc

#EndRegion
